import com.vividsolutions.jump.workbench.plugin.AbstractPlugIn;
import com.vividsolutions.jump.workbench.plugin.PlugInContext;
import com.vividsolutions.jump.*;
import com.vividsolutions.jump.feature.*;
import com.vividsolutions.jts.geom.*;
import java.util.*;
import javax.swing.JComboBox;

import com.vividsolutions.jump.workbench.ui.*;

import com.vividsolutions.jump.workbench.model.*;

public class soused extends AbstractPlugIn {
        
    public void initialize(PlugInContext context){
        context.getFeatureInstaller().addMainMenuItem(this, new String[] { "MojePlugIns", "soused" }, "soused", false, null, null);
    }
    
    public boolean execute(PlugInContext context) throws Exception {   
        double dist = 0;
        String name = "";
        
        Layer itemLayer = context.getWorkbenchContext().getLayerManager().getLayer(0);
        Collection selFeatures = (Collection)((SelectionManagerProxy)context.getActiveInternalFrame()).getSelectionManager().getFeaturesWithSelectedItems(itemLayer);
        FeatureCollection features = context.getWorkbenchContext().getLayerManager().getLayer(0).getFeatureCollectionWrapper().getWrappee();
        
        if (selFeatures.size()==0){
            MultiInputDialog dialog = new MultiInputDialog(context.getWorkbenchFrame(),getName(),true);
            dialog.addLabel("Nebyla vybrana zadna polozka");
            GUIUtil.centreOnWindow(dialog);
            dialog.setVisible(true);
           }
        
       else {
           Iterator it = selFeatures.iterator();
           Feature selF = (Feature)it.next();
           Coordinate A = selF.getGeometry().getCoordinate();
           
           for (Iterator i =features.iterator();i.hasNext();){
               Feature f = (Feature)i.next();
               Coordinate B = f.getGeometry().getCoordinate();
               double newDist = distance (A,B);
               if (dist == 0 && newDist !=0) dist=newDist;
               if ( dist >= newDist && newDist !=0){
                   dist=newDist;
                   name = (String)f.getAttribute("NAZOB");
                            
               }
        
       }     
       
       MultiInputDialog dialog = new MultiInputDialog(context.getWorkbenchFrame(),getName(),true);
            dialog.addLabel("Nejblizsim soudem obce" + selF.getAttribute ("NAZOB")+ "je obec" + name + "ve vzdalenosti" + dist);
            GUIUtil.centreOnWindow(dialog);
            dialog.setVisible(true);
       
       
       
       
    }
    
     return true;
  }
    
     private double distance(Coordinate A, Coordinate B) throws Exception {
        return Math.sqrt (((A.x-B.x)*(A.x-B.x)) + ((A.y-B.y)*(A.y-B.y)));
      }
        
}  